#include "integer.h"
#include "tff.h"

typedef struct {
	UINT l;
	UINT t;
	UINT r;
	UINT b;
} RECT;

typedef struct {
	UINT x;
	UINT y;
} POINT;


BOOL gd_boxfill (const RECT* rect, BYTE index);
BOOL gd_put_kanji (POINT point, WORD sjis, BYTE index);
BOOL gd_put_ank (POINT point, BYTE ank, BYTE index);
BOOL gd_put_7seg (POINT point, BYTE fnt, BYTE index);
void gd_put_str (POINT point, BYTE* str, UINT width, BYTE index);
void gd_enable(void);
void gd_disable(void);
BOOL gd_check(void);
BOOL gd_load_bmpfile (FIL* file, POINT point);
BYTE gd_get_pixel (POINT point);
void gd_put_pixel (POINT point, BYTE index);


#define	LCD_WIDTH	320
#define	LCD_HEIGHT	240

#define KANJI_W		12
#define	KANJI_H		12
#define	ANK_W		6
#define	ANK_H		12
#define	SEG7_W		11
#define	SEG7_H		17

#define	BLACK	0xF0
#define	RED		0xF1
#define	GREEN	0xF2
#define	YELLOW	0xF3
#define	BLUE	0xF4
#define	MAGENTA	0xF5
#define	CYAN	0xF6
#define	WHITE	0xF7
#define	GRAY	0xF8
#define	I_RED	0xF9
#define	I_GREEN	0xFA
#define	I_YELLOW	0xFB
#define	I_BLUE	0xFC
#define	I_MAGENTA	0xFD
#define	I_CYAN	0xFE
#define	I_WHITE	0xFF


