# V850ES Task Manager

	.set	N_TASK, 4		-- number of tasks

	.option	ep_label
	.option	new_fcall
	.section ".version", comment
	.str	"ca850 W3.10\0"
	.previous


#-- sbss section -----------------------------------------------
	.sbss

	.lcomm	svstack, 4, 4
#	void *svstack;

	.lcomm	taskid, 4, 4
#	UINT taskid;

	.lcomm	task, 8 * N_TASK, 4
#	struct {
#		union {
#			TSTAT tstat;		// +0
#			struct {
#				WORD status;	// +0
#				SHORT timer;	// +2
#			} st1;
#		} un1;
#		void *task_stack;		// +4
#	} task[N_TASK];



#-- program section --------------------------------------------
	.text


#-----------------------------------------
# Decrement task sleep timer
#
# void task_timerproc (void);

	.frame	_task_timerproc, 0
	.globl	_task_timerproc

_task_timerproc:
	movea	$task, gp, r10	-- r10 = &task[0];
	mov	N_TASK, r11			-- r11 = N_TASK;
L010:
	ld.h	2[r10], r12		-- decrement task timer with zero stopped;
	cmp	-1, r12
	jz	L012
	addi	-1, r12, r12
	jnc	L012
	st.h	r12, 2[r10]
L012:
	addi	8, r10, r10		-- r10++;
	addi	-1, r11, r11	-- r11--;
	jnz	L010				-- repeat until all task timer are processed

	jmp	[lp]




#-----------------------------------------
# Get task status
#
# TSTAT get_task_stat (UINT task_id);

	.frame	_get_task_stat, 0
	.globl	_get_task_stat

_get_task_stat:
	mov	r0, r10
	cmp	N_TASK, r6				-- if task_id >= N_TASK, return with 0.
	jnc	L190
	shl	3, r6					-- r6 = &task[task_id];
	add	gp, r6
	ld.w	$task+0[r6], r10	-- return with task status.
L190:
	jmp	[lp]




#-----------------------------------------
# Start task
#
# TSTAT start_task (UINT task_id, void(*task_entry)(void*), void *task_sp, void *argument);

	.frame	_start_task, 0
	.globl	_start_task

_start_task:
	mov	0, r10
	cmp	N_TASK, r6				-- if task_id >= N_TASK, return.
	jnc	L201
	shl	3, r6					-- r6 = &task[task_id];
	add	gp, r6
	addi	-8, r8, r11
	ld.hu	$task+0[r6], r12	-- skip when the task id is in-use
	cmp	0, r12
	jnz	L201
	mov	3, r10
	st.w	r9, -4[r8]			-- save argument
	st.w	r7, -8[r8]			-- save task entry point
	st.w	r11, $task+4[r6]	-- initialize task sp
	st.w	r10, $task+0[r6]	-- set task status START and return
L201:
	jmp	[lp]




#-----------------------------------------
# Wakeup task
#
# void wakeup_task (UINT task_id);

	.frame	_wakeup_task, 0
	.globl	_wakeup_task

_wakeup_task:
	cmp	N_TASK, r6				-- if task_id >= N_TASK, return.
	jnc	L251
	shl	3, r6					-- r6 = &task[task_id];
	add	gp, r6
	st.h	r0, $task+2[r6]		-- clear the task timer
L251:
	jmp	[lp]




#-----------------------------------------
# Dispatch a task
#
# void dispatch_task (UINT task_id);

	.frame	_dispatch_task, 0
	.globl	_dispatch_task

_dispatch_task:
	cmp	N_TASK, r6				-- if task_id >= N_TASK, return.
	jnc	L309
	st.w	r6, $taskid			-- set current task
	shl	3, r6					-- r6 = &task[task_id];
	add	gp, r6
	ld.w	$task+0[r6], r10	-- r10 = task status and timer value
	cmp	1, r10					-- if status == READY && !timer, resume task
	je	L301
	cmp	3, r10					-- if status == START && !timer, start task
	je	L302
L309:
	jmp	[lp]					-- else skip this task

L302: -- start from the task entry
	mov	1, r10					-- set task status READY
	st.h	r10, $task+0[r6]
	prepare	0xFFF, 0			-- save manager context
	st.w	sp, $svstack
	--
	ld.w	$task+4[r6], sp		-- task sp
	ld.w	0[sp], r10			-- entry point
	ld.w	4[sp], r6			-- argument
	addi	8, sp, sp
	mov32	#exittask, lp		-- exit point
	jmp	[r10]					-- start task

L301: -- resume from sleep()
	prepare	0xFFF, 0			-- save manager context
	st.w	sp, $svstack
	--
	ld.w	$task+4[r6], sp		-- task sp
	dispose	0, 0xFFF, [lp]		-- load task context and resume task




#-----------------------------------------
# Release CPU for other task
#
# void sleep (WORD timer_ms);

	.frame	_sleep, 0
	.globl	_sleep

_sleep:
	prepare	0xFFF, 0			-- save task context
	ld.w	$taskid, r11
	shl	3, r11
	add	gp, r11
	st.w	sp, $task+4[r11]	-- save task sp
	st.h	r6, $task+2[r11]	-- set sleep timer
L401:
	ld.w	$svstack, sp		-- load manager context and return to manager
	dispose	0, 0xFFF, [lp]


exittask:	-- task exit point
	ld.w	$taskid, r11		-- set task status NON-EXISTENT
	shl	3, r11
	add	gp, r11
	st.w	r0, $task+0[r11]
	jr	L401					-- return to manager



